//---------------------------------------------------------------------------

#ifndef ImageExH
#define ImageExH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>

typedef void __fastcall(__closure *CB_Action)(TObject *Sender);

//---------------------------------------------------------------------------
class PACKAGE TImageEx : public TImage
{
private:

       CB_Action  FOnMouseLeave;
       CB_Action  FOnMouseEnter;

protected:

       void __fastcall FMouseLeave(TMessage &Msg);
       void __fastcall FMouseEnter(TMessage &Msg);

       BEGIN_MESSAGE_MAP
         MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage, FMouseLeave)
         MESSAGE_HANDLER(CM_MOUSEENTER, TMessage, FMouseEnter)
       END_MESSAGE_MAP(TImage)

public:
        __fastcall TImageEx(TComponent* Owner);
__published:

    __property CB_Action OnMouseLeave={read= FOnMouseLeave,write= FOnMouseLeave};
    __property CB_Action OnMouseEnter={read= FOnMouseEnter,write= FOnMouseEnter};

};
//---------------------------------------------------------------------------
#endif
